#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/file.h>
#include <linux/fs.h>
#include <linux/miscdevice.h>
#include <linux/mm.h>

static long my_ioctl(struct file *file_, unsigned int cmd, unsigned long arg) {
	if (cmd == 0x1337) {
		int res;
		struct page *p;
		unsigned int marker = arg & 0xfffUL;
		unsigned long userptr = arg & ~0xfffUL;
		res = get_user_pages_fast(userptr, 1, 1, &p);
		if (res != 1) {
			pr_err("dump_page: get_user_pages_fast failed with %d\n", res);
			return res;
		}
		pr_err("dump_page: ---------- STARTING DUMP ----------\n");
		pr_err("dump_page: DUMP MARKER: 0x%x\n", marker);
		dump_page(p, "dump requested via ioctl");
		pr_err("dump_page: ==========  END OF DUMP  ==========\n");
		put_page(p);
		return 0;
	}
	return -EINVAL;
}

static const struct file_operations my_fops = {
	.owner = THIS_MODULE,
	.unlocked_ioctl = my_ioctl
};

static struct miscdevice my_miscdev = {
	.minor = 0,
	.name = "dump_page",
	.fops = &my_fops,
	.mode = 0666
};

static int __init my_init(void) {
	return misc_register(&my_miscdev);
}

static void __exit my_exit(void) {
	misc_deregister(&my_miscdev);
}

module_init(my_init);
module_exit(my_exit);
MODULE_LICENSE("GPL v2");
